type operator=
 Plus
|Minus
|Times
|Divide
|Mod
|Lessthan
|Greaterthan
|Lessequal
|Greaterequal
|Equal
|Notequal
|Logicaland
|Logicalor

type unary_operator=
 Negation
|Ninus

type id=string

type expression=
 Lval of lvalue
|Const of constant_option
|Assign of lvalue*expression
|Binop of expression*operator*expression
|Unaryop of unary_operator*expression
|Comma of expression*expression
|This of expression*expression
|Funcall of id*expression list

and lvalue=
 Variable of id
|Array of id*expression
|Thisl of expression



and constant=
 Intc of int
|Charc of char
|Floatc of float

and constant_option=
 None 
|Consopt of constant


type dtype=
 Int
|Char
|Float
|Video
|Void

type i_init=
Init of id*constant_option


type declaration=
 VarDecl of variable_declaration
|ArraDecl of array_declaration

and variable_declaration=
 Ddecl of dtype*(i_init list)

and array_declaration=
 Adecl of dtype*id*int

type argument=
Arg of dtype*id

type statement=
 Expression of expression
|Compound of declaration list*statement list 
|If of expression*statement*statement
|While of expression*statement 
|For of  expression*expression*expression*statement
|Continue
|Break
|Return of expression 
|Load of id*string*expression*expression
|Store of id*string
|Insert of id*id*expression
|Delete of id*expression*expression
|Copy of id*expression*expression*id
|Update of id*expression*expression*statement

type func=
 Func of dtype*id*argument list*statement

type program=
 Pro of func list

